#ifndef IDATATRANSFORMFACTORY_H
#define IDATATRANSFORMFACTORY_H

#include "PersistencySvc/IDataTransformInfo.h"
#include "PluginManager/PluginFactory.h"

namespace pool {

  class IDataTransformFactory : public seal::PluginFactory< IDataTransformInfo >
  {
  public:
    static IDataTransformFactory* get();
    IDataTransform* create( Iterator info ) const;
    IDataTransform* create( const std::string& name ) const;

  private:
    IDataTransformFactory();
    static IDataTransformFactory s_instance;
  };

}

#endif
