/* C++ header file: Objectivity/DB DDL version 6.1.0         */

#ifndef CMS_TEST0_H_
#define CMS_TEST0_H_

#include <vector>

namespace TestO {

  struct A {
    A() : i(0) {}
    A(const A& c) : i(c.i) {}
    virtual ~A(){}
    A& operator=(const A& c) { i = c.i; return *this; }
    int i;
  };


  struct B : public A {
    virtual ~B(){}
    virtual int j() const =0;

  };

  struct C : public B {
    C(){}
    virtual ~C(){}
    virtual int j() const { return jj;}

    int jj;

  };


  struct D {
    D(){}
    virtual ~D(){}
    int i;
  };

  struct F {
    F() : i(0) {}
    F(const F& c) : i(c.i) {}
    ~F(){}
    F& operator=(const F& c) { i = c.i; return *this; }
    int i;
  };
}

namespace TestO {
  template <class T> struct E;

  namespace TTT {
    class G {};
    class A {};
    template<class T> struct H {
      std::vector<pool::Ref<E<T> > > m_refs;
    };
  };
  template <class T> struct E : public D, public std::vector<T>  {
    std::vector<pool::Ref<E<T> > > ref_e_vector;
    std::vector<TTT::H<TTT::A> >   g_vector;
    std::vector<TTT::H<float> >    f_vector;
    virtual ~E() {}
  };
}

namespace Test1  {
  struct Z;
  struct B;
  struct Q{
  };
  struct A{
    std::vector<pool::Ref<B> > v;
  };

  struct B   {
    virtual ~B(){}
    virtual void f() const =0;
  protected:
    pool::Ref<Q> q;
    pool::Ref<A> a;
    pool::Ref<Z> z;
  };

  template<typename T>
  struct C : public B {
    virtual void f() const {}
    T j;
  };

};

#endif /* !defined(CMS_TEST0_H_) */
