#include "pool/TestBase.h"
#include "inheritance.h"
#include "TROOT.h"
#include "TFile.h"
#include "TTree.h"
#include "TBranch.h"
#include "TStreamerInfo.h"

namespace pool  {
  static int counter = 0;
  void stream_aggregate(TBuffer& b, void* pObj, int )
  {
    inheritance_aggregate* o = (inheritance_aggregate*)pObj;
    std::cout << ++counter << " - Called customized streamer." << std::endl;
    if ( b.IsReading() )  {
      b >> o->m_data;
    }
    else  {
      b << o->m_data;
    }
  }

  struct Inheritance : public TestBase {

    /// Standard Constructor
    Inheritance()    : TestBase(0, "", "")     {    }

    /// Standard Destructor
    virtual ~Inheritance()               {    }
    
    /// write objects to the persistent store
    DbStatus write()       {
      TClass* c3  = gROOT->GetClass("inheritance_base_base");
      c3->BuildRealData(0);    // Force BuildReadData
//      c3->SetStreamer("m_agg0", stream_aggregate);
      c3->GetStreamerInfo()->ls();
      TClass* c2  = gROOT->GetClass("inheritance_base");
      c2->BuildRealData(0);    // Force BuildReadData
//      c3->SetStreamer("m_agg0", stream_aggregate);
//      c2->SetStreamer("m_agg1", stream_aggregate);
      c2->GetStreamerInfo()->ls();
      TClass* c1  = gROOT->GetClass("inheritance");
      c1->BuildRealData(0);    // Force BuildReadData
//      c3->SetStreamer("m_agg0", stream_aggregate);
//      c1->SetStreamer("m_agg1", stream_aggregate);
//      c1->SetStreamer("m_agg2", stream_aggregate);
      c1->GetStreamerInfo()->ls();

      TFile *f    = new TFile("inheritance.root", "RECREATE", "Root inheritance test");
      TTree *tree = new TTree("T","An example of a ROOT tree");
      inheritance* obj = new inheritance();
      TBranch *b = tree->Branch("inheritance", "inheritance", &obj, 1024, 99);
      if ( 0 == b ) {
        return DbStatus::ERROR;
      }
      //gDebug = 3;
      for ( int i = 0; i < 10; ++i) {
        obj->m_agg1.m_data = i;
        obj->m_agg2.m_data = 10000*i;
        tree->Fill();
      }
      f->Close();
      return DbStatus::SUCCESS;
    }
    /// read objects from the persistent store
    DbStatus read()  {
      return DbStatus::SUCCESS;
    }
  };
}

pool::TestRunner<pool::Inheritance> s_testInheritance("Inheritance");
