#ifndef ATTRIBUTEVALUEACCESSOR_H
#define ATTRIBUTEVALUEACCESSOR_H

/// @file 
/// @author Jakub.Moscicki@cern.ch (kuba)

# include "Attribute.h"

# include <cassert>

# include <iostream>

namespace pool 
{
/**
 * @name Internal interface to access value object (implementation) of an Attribute.
 *  
 * The motivation was to optimize root collections giving the address of the memory address
 * of an Attribute data member.
 */

//@{

inline AttributeBaseValue& AttributeValueAccessor(Attribute& attr)
{
  assert(attr.m_attr.get());
  return *attr.m_attr.get();
}

inline const AttributeBaseValue& AttributeValueAccessor(const Attribute& attr)
{
  assert(attr.m_attr.get());
  return *attr.m_attr.get();
}

//@}

}

#endif
