#ifndef ATTRIBUTEVALUECONSTRUCTOR_H
#define ATTRIBUTEVALUECONSTRUCTOR_H

/// @file 
/// @author Jakub.Moscicki@cern.ch (kuba)

#include "AttributeList/Attribute.h"

namespace pool
{
/**
 * Internal interface for constructing Attributes from value objects.
 * Not exposed to general public but useful for implementors of other packages which need
 * to have the control over the internal construction of attribute objects.
 */
inline Attribute
AttributeValueConstructor(boost::shared_ptr<AttributeBaseValue> ap, const AttributeSpecification&spec)
{
  return Attribute(ap,spec);
}

}

#endif
