
#include "CollectionBase/ICollectionService.h"
#include "CollectionBase/ICollection.h"

template<class T>
inline
pool::Collection<T>
pool::CollectionSvc::createAndRegister( pool::IDataSvc* dataSvc, 
					const std::string& type,
					const std::string& connection,
					const std::string& name,
					const std::string& logicalName,
					MetaDataEntry* collectionMetaData,
					bool authorizeReplace,
					pool::IFileCatalog* catalog )
{
   return Collection<T>( createAndRegister(dataSvc, type, connection, name, logicalName, collectionMetaData, authorizeReplace, catalog) );
}



template <class T> inline  pool::Collection<T> 
pool::CollectionSvc::openWithPhysicalName( pool::IDataSvc* dataSvc, 
					   const std::string& physicalName,
					   bool readOnly,
					   pool::IFileCatalog* catalog)
{
   return Collection<T>( openWithPhysicalName(dataSvc, physicalName, readOnly, catalog) );
}


template <class T> inline  pool::Collection<T>
pool::CollectionSvc::openWithLogicalName( pool::IDataSvc* dataSvc, 
					  const std::string& logicalName,
					  bool readOnly,
					  pool::IFileCatalog* catalog)
{
   return Collection<T>( openWithLogicalName(dataSvc, logicalName, readOnly, catalog) );
}  


template <class T> inline  pool::Collection<T> 
pool::CollectionSvc::openWithGuid( pool::IDataSvc* dataSvc, 
                                   const FileCatalog::FileID& id,
                                   bool readOnly,
                                   pool::IFileCatalog* catalog)
{
   return Collection<T>( openWithGuid(dataSvc, id, readOnly, catalog) );
}    


template <class T> inline typename pool::Collection<T>::Iterator 
pool::CollectionSvc::select( pool::IDataSvc* dataSvc, 
			     const std::string& objectQuery,
			     const std::string& collectionQuery,
			     const std::string& objectIteratorOptions,
			     pool::IFileCatalog* catalog)
{
   return typename pool::Collection<T>::Iterator( select(dataSvc, objectQuery, collectionQuery,  objectIteratorOptions, catalog) );
}

  
