#ifndef POOL_OBJECTDELETEPOLICY_H
#define POOL_OBJECTDELETEPOLICY_H

namespace pool    {

/** @class ObjectDeletePolicy ObjectDeletePolicy.h
   
    @author Giacomo Govi
    @date 09/07/2003
**/
  class ObjectDeletePolicy  {

  public:


    enum Policy {DONOT_DELETE, DO_DELETE};

    static Policy GLOBAL_DEFAULT;

    static const ObjectDeletePolicy defaultPolicy();

    static void setDefaultPolicy(Policy policy);

    ObjectDeletePolicy():m_oncache(true),m_onref(true){}
  
    ObjectDeletePolicy(bool oncache, bool onref):m_oncache(oncache),
                                                              m_onref(onref){}

    ObjectDeletePolicy(const ObjectDeletePolicy& aPolicy):m_oncache(aPolicy.m_oncache),
                                                          m_onref(aPolicy.m_onref){}

    virtual ~ObjectDeletePolicy(){}

    ObjectDeletePolicy& operator=(const ObjectDeletePolicy& aPolicy){
      m_oncache = aPolicy.m_oncache;
      m_onref = aPolicy.m_onref;
      return *this;
    }

    bool operator==(const ObjectDeletePolicy& aPolicy) const {
      return (m_oncache==aPolicy.m_oncache)   &&
             (m_onref==aPolicy.m_onref);
    }
  
    void setOnCache(bool flag){
      m_oncache = flag;
    }

    void setOnRef(bool flag){
      m_onref = flag;
    }

    bool onCache() const {
      return m_oncache;
    }

    bool onRef() const {
      return m_onref;
    }

  private: 
   
    bool m_oncache;
    
    bool m_onref;

  };   // class ObjectDeletePolicy
}      // namespace pool

#endif  // POOL_OBJECTDELETEPOLICY_H
