#include "CacheTransactionObserver.h"
#include "CacheSvc.h"

pool::CacheTransactionObserver::CacheTransactionObserver(CacheSvc& aCacheSvc): 
                                                        m_cacheSvc(aCacheSvc){}


/// Responds to a committing of a transaction
bool pool::CacheTransactionObserver::respondToCommit(){
  return m_cacheSvc.resetMarkedObjects();
}

/// Responds to an aborting of a transaction
bool pool::CacheTransactionObserver::respondToRollBack(){
  return m_cacheSvc.unmarkObjects();
}
