#include "FileCatalog/FCImpl.h"
#include "FileCatalog/URIParser.h"
//#include "FileCatalog/FCImplPluginFactory.h"
//#include "FileCatalog/FCMetaImplPluginFactory.h"
#include "FileCatalog/FCImpl.h"
#include "FileCatalog/FCMetaImpl.h"
#include "CoralBase/MessageStream.h"
#include "FileCatalog/FCException.h"
#include "Reflex/PluginService.h"

#include "RVersion.h"
#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
using namespace ROOT;
#endif

namespace pool{
  FCImpl* FCImplBuilder::BuildFCImpl(const std::string& contact){
    FCImpl* fcimpl=0;
    URIParser p(contact);
    std::string uriprefix,url;
    try{
      p.parse();
      uriprefix=p.prefix();
      url=p.url();

      /*
      if(uriprefix.empty()||uriprefix=="XMLFileCatalog"){
        fcimpl=FCImplPluginFactory::get()->create( "xmlcatalog" );
      }else{
        fcimpl=FCImplPluginFactory::get()->create( uriprefix );
      }
      */

      if(uriprefix.empty()||uriprefix=="XMLFileCatalog"){
        fcimpl=Reflex::PluginService::CreateWithId<FCImpl*>( std::string("xmlcatalog") );
      }else{
        fcimpl=Reflex::PluginService::CreateWithId<FCImpl*>( uriprefix );
      }


      if(fcimpl==0)
        throw pool::Exception(std::string("failed to load file catalog plugin: ")+url ,"FCImplBuilder::BuildFCImpl ",
                              "FileCatalog" );
      fcimpl->setURL(url);
      fcimpl->setType(uriprefix);
      return fcimpl;
    }catch( ... ){
      throw;
    }
  }

  FCMetaImpl* FCImplBuilder::BuildFCMetaImpl( FCImpl* fc){
    coral::MessageStream fclog( "FCImplBuilder::BuildFCMetaImpl");
    FCMetaImpl* metaimpl=0;
    try{
      std::string mytype=fc->implType();

      /*
      if( mytype.empty()||mytype=="XMLFileCatalog"){
        metaimpl=FCMetaImplPluginFactory::get()->create("xmlcatalog_meta",fc);
      }else{
        metaimpl=FCMetaImplPluginFactory::get()->create(mytype+std::string("_meta"),fc);
      }
      */

      if(mytype.empty()||mytype=="XMLFileCatalog"){
        metaimpl=Reflex::PluginService::CreateWithId<FCMetaImpl*>( std::string("xmlcatalog_meta"), fc );
      }else{
        metaimpl=Reflex::PluginService::CreateWithId<FCMetaImpl*>( mytype+std::string("_meta"), fc);
      }

      if(!metaimpl){
        fclog<<coral::Info<<"no metadata catalog plugin found for "<<mytype<<coral::MessageStream::endmsg;
      }
    }catch(...){
      throw;
    }
    return metaimpl;
  }
}//ns pool
