inline 
pool::ObjectRelationalMappingElement::ObjectRelationalMappingElement():
  m_elementType(pool::ObjectRelationalMappingElement::Undefined),
  m_parentType(pool::ObjectRelationalMappingElement::Undefined),
  m_isDependentTree(false),
  m_scopeName(""),
  m_variableName(""),
  m_variableNameForSchema(""),
  m_variableNameForColumn(""),
  m_variableType(""),
  m_tableName(""),
  m_columnNames(),
  m_subElements(),
  m_mainTableName(""),
  m_parentClassMappingElement(0){
}

inline 
pool::ObjectRelationalMappingElement::ObjectRelationalMappingElement( const ObjectRelationalMappingElement& element):
  m_elementType(element.m_elementType),
  m_parentType(element.m_parentType),
  m_isDependentTree(element.m_isDependentTree),
  m_scopeName(element.m_scopeName),
  m_variableName(element.m_variableName),
  m_variableNameForSchema(element.m_variableNameForSchema),
  m_variableNameForColumn(element.m_variableNameForColumn),
  m_variableType(element.m_variableType),
  m_tableName(element.m_tableName),
  m_columnNames(element.m_columnNames),
  m_subElements(element.m_subElements),
  m_mainTableName(element.m_mainTableName),
  m_parentClassMappingElement(0) {
  if(element.m_parentClassMappingElement) m_parentClassMappingElement = new ObjectRelationalMappingElement(*element.m_parentClassMappingElement);
}

inline pool::ObjectRelationalMappingElement& 
pool::ObjectRelationalMappingElement::operator=(const ObjectRelationalMappingElement& element){
  if(this != &element){
     m_elementType = element.m_elementType;
     m_parentType = element.m_parentType;
     m_isDependentTree = element.m_isDependentTree;
     m_scopeName = element.m_scopeName;
     m_variableName = element.m_variableName;
     m_variableNameForSchema = element.m_variableNameForSchema;
     m_variableNameForColumn = element.m_variableNameForColumn;
     m_variableType = element.m_variableType;
     m_tableName = element.m_tableName;
     m_columnNames = element.m_columnNames;
     m_subElements = element.m_subElements;
     m_mainTableName = element.m_mainTableName;
     if(m_parentClassMappingElement) delete m_parentClassMappingElement;
     m_parentClassMappingElement = 0;
     if(element.m_parentClassMappingElement) m_parentClassMappingElement = new ObjectRelationalMappingElement(*element.m_parentClassMappingElement);
  }
  return *this;
}


inline pool::ObjectRelationalMappingElement::iterator
pool::ObjectRelationalMappingElement::begin()
{
  return m_subElements.begin();
}

inline pool::ObjectRelationalMappingElement::const_iterator
pool::ObjectRelationalMappingElement::begin() const
{
  return m_subElements.begin();
}

inline pool::ObjectRelationalMappingElement::iterator
pool::ObjectRelationalMappingElement::end()
{
  return m_subElements.end();
}

inline pool::ObjectRelationalMappingElement::const_iterator
pool::ObjectRelationalMappingElement::end() const
{
  return m_subElements.end();
}

inline pool::ObjectRelationalMappingElement::iterator
pool::ObjectRelationalMappingElement::find( const std::string& key )
{
  return m_subElements.find( key );
}

inline pool::ObjectRelationalMappingElement::const_iterator
pool::ObjectRelationalMappingElement::find( const std::string& key ) const
{
  return m_subElements.find( key );
}

inline bool
pool::ObjectRelationalMappingElement::removeSubElement( const std::string& key ) 
{
  return m_subElements.erase( key )>0;
}

inline pool::ObjectRelationalMappingElement::ElementType
pool::ObjectRelationalMappingElement::elementType() const
{
  return m_elementType;
}

inline pool::ObjectRelationalMappingElement::ElementType
pool::ObjectRelationalMappingElement::parentType() const
{
  return m_parentType;
}

inline bool 
pool::ObjectRelationalMappingElement::isDependentTree() const {
  return m_isDependentTree;
}

inline const pool::ObjectRelationalMappingElement*
pool::ObjectRelationalMappingElement::parentClassMappingElement() const {
  return m_parentClassMappingElement;
}

inline const std::string&
pool::ObjectRelationalMappingElement::scopeName() const
{
  return m_scopeName;
}

inline const std::string&
pool::ObjectRelationalMappingElement::variableName() const
{
  return m_variableName;
}

inline const std::string&
pool::ObjectRelationalMappingElement::variableNameForSchema() const
{
  return m_variableNameForSchema;
}

inline const std::string&
pool::ObjectRelationalMappingElement::variableNameForColumn() const
{
  return m_variableNameForColumn;
}

inline const std::string&
pool::ObjectRelationalMappingElement::variableType() const
{
  return m_variableType;
}

inline const std::string&
pool::ObjectRelationalMappingElement::tableName() const
{
  return m_tableName;
}

inline const std::vector< std::string >&
pool::ObjectRelationalMappingElement::columnNames() const
{
  return m_columnNames;
}
   
inline const std::string&
pool::ObjectRelationalMappingElement::mainTableName() const {
  return m_mainTableName;
}
