#include "CArrayIteratorHandler.h"
#include "RelationalStorageServiceException.h"
#include "Reflex/Object.h"

pool::RelationalStorageService::CArrayIteratorHandler::CArrayIteratorHandler( const void* startAddress,
                                                                              const TypeH& iteratorReturnType ):
  m_returnType(iteratorReturnType),
  m_currentElement(startAddress){

}

pool::RelationalStorageService::CArrayIteratorHandler::~CArrayIteratorHandler(){}

void
pool::RelationalStorageService::CArrayIteratorHandler::increment()
{
  m_currentElement = static_cast< const char* >( m_currentElement) + m_returnType.SizeOf();
}


void*
pool::RelationalStorageService::CArrayIteratorHandler::object()
{
  return const_cast<void*>(m_currentElement);
}


TypeH
pool::RelationalStorageService::CArrayIteratorHandler::returnType() const
{
  return m_returnType;
}
