#ifndef CARRAY_ITERATOR_HANDLER_H
#define CARRAY_ITERATOR_HANDLER_H

#include "Reflex/Type.h"
#include "IContainerIteratorHandler.h"
#include "RVersion.h"

#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
 typedef ROOT::Reflex::Type TypeH;
#else
 typedef Reflex::Type TypeH;
#endif

namespace pool {

  namespace RelationalStorageService {

    class CArrayIteratorHandler : virtual public IContainerIteratorHandler {
    public:
      /// Constructor
      CArrayIteratorHandler( const void* startAddress,
                             const TypeH& iteratorReturnType );

      /// Destructor
      ~CArrayIteratorHandler();

      /// Increments itself
      void increment();

      /// Returns the current object
      void* object();

      /// Returns the return type of the iterator dereference method
      TypeH returnType() const;

    private:

      /// The return type of the iterator dereference method
      TypeH m_returnType;
      
      /// Current element object pointer
      const void* m_currentElement;
    };

  }

}

#endif
