#ifndef CONTAINER_HANDLER_FACTORY_H
#define CONTAINER_HANDLER_FACTORY_H

#include "RVersion.h"

#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
namespace ROOT {
  namespace Reflex {
  class Type;
  }}
#else
namespace Reflex {
  class Type;
}
#endif

namespace pool {

  namespace RelationalStorageService {

    class IContainerHandler;

    /**
       @class ContainerHandlerFactory ContainerHandlerFactory.h
       Factory class for IContainerHandle objects.
     */

    class ContainerHandlerFactory {
    public:
#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
      static IContainerHandler* newContainerHandler( const ROOT::Reflex::Type& containerType );
#else
      static IContainerHandler* newContainerHandler( const Reflex::Type& containerType );
#endif
    };

  }

}

#endif
