#ifndef RELATIONALSTORAGESERVICE_MAPPINGINFORMATION_H
#define RELATIONALSTORAGESERVICE_MAPPINGINFORMATION_H

#include <string>

namespace pool {

  class ObjectRelationalMappingElement;

  namespace RelationalStorageService {

    /**
       @class MappingInformation MappingInformation.h

       Simple container holding a mapping element reference and a version.
     */

    class MappingInformation {
    public:
      /// Constructor
      MappingInformation( const pool::ObjectRelationalMappingElement& mappingElement,
                          const std::string& theVersion );

      /// Destructor
      ~MappingInformation() {}

      /// The mapping element
      const pool::ObjectRelationalMappingElement& element;

      /// The version
      std::string version;
    };
  }
}


inline
pool::RelationalStorageService::MappingInformation::MappingInformation( const pool::ObjectRelationalMappingElement& mappingElement,
                                                                        const std::string& theVersion ):
  element( mappingElement ),
  version( theVersion )
{}

#endif
