#ifndef RELATIONALPOOLPOLYMORPHICCONTAINER_H
#define RELATIONALPOOLPOLYMORPHICCONTAINER_H

#include "RelationalPoolContainer.h"

namespace pool {

  namespace RelationalStorageService {

    /** @class RelationalPoolPolymorphicContainer RelationalPoolPolymorphicContainer.h
     *
     * Extension of the default implementation DbContainerImp for the object storage
     * using the POOL Relational backend handling polymorphic objects
     */

    class RelationalPoolPolymorphicContainer : public RelationalPoolContainer
    {
    public:
      /// Constructor
      explicit RelationalPoolPolymorphicContainer( pool::IOODatabase* idb );

      /// Destructor
      ~RelationalPoolPolymorphicContainer();

      /// Fetch next object address of the selection to set token
      pool::DbStatus fetch( pool::DbSelect& selection );

      /// Fetch a column identified by its link in the container
      pool::DbStatus fetch( const pool::DbLink& linkH,
                            pool::DbLink& stmt );

    protected:
      /// Loads the correct container from the database manager
      PoolBaseContainerManager* createContainerManager( PoolDatabaseManager& databaseManager,
                                                        const std::string& containerName,
                                                        const pool::DbTypeInfo* info );
    };

  }

}

#endif
