#ifndef SPECIALCONTAINER_HANDLER_H
#define SPECIALCONTAINER_HANDLER_H

#include "IContainerHandler.h"
#include "RVersion.h"

namespace pool {

  namespace RelationalStorageService {
    
#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
    typedef ROOT::Reflex::Type TypeH;
#else
    typedef Reflex::Type TypeH;
#endif
    
    class SpecialContainerHandler : virtual public IContainerHandler {

    public:
      /// Constructor
      explicit SpecialContainerHandler( const TypeH& dictionary );

      /// Destructor
      ~SpecialContainerHandler();

      /// Returns the size of the container
      size_t size( const void* address );

      /// Returns an initialized iterator
      IContainerIteratorHandler* iterate( const void* address );

      /// Appends a new element and returns its address of the object reference
      void appendNewElement( void* address, void* data );

      /// Clear the content of the container
      void clear( const void* address );

      /// Returns the iterator return type
      TypeH iteratorReturnType() const;

    private:
      /// The handler of the unserlying container
      IContainerHandler* m_containerHandler;

      /// The offset of the underlying container
      int m_containerOffset;
    };

  }

}

#endif
