#include <iostream>
#include <exception>
#include <memory>

#include "TestApp.h"

#include "POOLCore/Exception.h"


int main( int, char** )
{
  try {
    std::auto_ptr< TestApp > test( new TestApp );

    test->run();
  }
  catch ( pool::Exception& e ) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  catch ( std::exception& e ) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  catch ( ... ) {
    std::cerr << "Unhandled exception" << std::endl;
    return 1;
  }
  std::cout << "[OVAL] Success" << std::endl;
  return 0;
}
